#ifndef XCLEAF_H
#define XCLEAF_H

#include "xasset.h"

#include <QVector>

class XCLeaf : public XAsset
{
public:
    explicit XCLeaf();

    void ParseData(QDataStream *aStream) override;

    quint16 GetFirstCollAabbIndex() const;
    void SetFirstCollAabbIndex(quint16 index);

    quint16 GetCollAabbCount() const;
    void SetCollAabbCount(quint16 count);

    int GetBrushContents() const;
    void SetBrushContents(int contents);

    int GetTerrainContents() const;
    void SetTerrainContents(int contents);

    QVector<float> GetMins() const;
    void SetMins(QVector<float> aMins);

    QVector<float> GetMaxs() const;
    void SetMaxs(QVector<float> aMaxs);

    int GetLeafBrushNode() const;
    void SetLeafBrushNode(int node);

    qint16 GetCluster() const;
    void SetCluster(qint16 cluster);

private:
    quint16 mFirstCollAabbIndex;
    quint16 mCollAabbCount;
    int mBrushContents;
    int mTerrainContents;
    QVector<float> mMins;
    QVector<float> mMaxs;
    int mLeafBrushNode;
    qint16 mCluster;
};

#endif // XCLEAF_H
